{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit I_Information;

interface

//{$define testing}

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QButtons, QMenus, Math, Qt, QComCtrls, 
  IniFiles, Spin, Controls, StdCtrls, Buttons, ExtCtrls;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus, Math, ComCtrls, Spin, IniFiles;
{$endif}

type
  TInverseInfo = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    cbType: TComboBox;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Select1: TBitBtn;
    Select2: TBitBtn;
    Select3: TBitBtn;
    Select4: TBitBtn;
    Next: TButton;
    Back: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Panel3: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Label2: TLabel;
    Edit12: TEdit;
    Select5: TBitBtn;
    CheckBox3: TCheckBox;
    SpinEdit1: TSpinEdit;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    Bevel1: TBevel;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbTypeChange(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Select3Click(Sender: TObject);
    procedure Select4Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Language;
    procedure TableEdit3Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Select5Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    AllowChangeLanguage: Boolean;

  public
  end;

var
  InverseInfo: TInverseInfo;

implementation

uses WASH1dMAIN, StringGrid, Simulation, Recent, W_Information,
  RC_Params, K_Params;

{$R *.xfm}
//--------------------------------------------------------------
procedure TInverseInfo.FormShow(Sender: TObject);
begin
  DialogBox := -1;
  AllowChangeLanguage := False;
  SpinEdit1.Value := Tensio;
//  SpinEdit1Change(Sender);
  cbType.ItemIndex := IPET_type - 1;
  if independent = 1 then
    CheckBox1.Checked := True
  else
    CheckBox1.Checked := False;
  case IPET_type of
  1:begin
      if UseOutFlowForK = 1 then
        CheckBox4.Checked := True
      else
        CheckBox4.Checked := False;
      if UseAdditionalHyConData = 1 then
        CheckBox3.Checked := True
      else
        CheckBox3.Checked := False;
    end;
  2:begin
      if UseOutFlowForK = 1 then
        CheckBox4.Checked := True
      else
        CheckBox4.Checked := False;
      if (l_bc_type = 4) and (UseOutFlowForK = 0) then
        CheckBox5.Checked := True
      else
        CheckBox5.Checked := False;
    end;
  end;
  if (AddRetData  = 1) or (IPET_type = 1) then
    CheckBox2.Checked := True
  else
    CheckBox2.Checked := False;
  cbTypeChange(Sender);
  CheckBox2Click(Sender);
  CheckBox3Click(Sender);
  SpinEdit1Change(Sender);
  AllowChangeLanguage := True;
  Language;
  dumint := 9999;
end;

procedure TInverseInfo.cbTypeChange(Sender: TObject);
begin
  IPET_type := cbType.ItemIndex + 1;
  Label6.Visible := False;
  Label7.Visible := False;
  Edit2.Visible  := False;
  Edit7.Visible  := False;
  Edit1.Left := 212;
  Edit1.Text := FloatToStr(W_end);
  CheckBox3.Visible := True;
  fl_outflow := TrimLeft(fl_outflow);
  case IPET_Type of
    1:begin
        fl_CumEvap := TrimLeft(fl_CumEvap);
       // if (fl_CumEvap = '') and (dumint = 9999) then Select2Click(sender);
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_CumEvap);
        Label1.Visible := False;
        Label4.Visible := True;
        Label5.Visible := True;
        Edit1.Visible  := False;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        Edit6.Visible  := True;
        SpinEdit1.Enabled := False;
        Select2.Visible   := True;
        Select3.Visible   := True;
        Select4.Visible   := True;
        Select2.Enabled := True;
        CheckBox5.Enabled := False;
        Edit5.Visible  := True;
        Label2.Enabled := False;
        Label4.Enabled := True;
        Label5.Visible := True;
        Select3.Visible := True;
        fl_profile := TrimLeft(fl_profile);
        {
        if (fl_profile = '') and (dumint = 9999) then
          Select3Click(sender);
        }
        Edit5.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
        fl_retention := TrimLeft(fl_retention);
        {
        if (fl_retention = '') and (dumint = 9999) then
          Select4Click(Sender);
        }
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        CheckBox2.Checked := True;
        CheckBox2.Enabled := True;
        CheckBox3.Enabled := True;
        CheckBox1.Enabled := False;
        Panel3.Top := 265;
      end;
    2:begin
        Label1.Visible := True;
        Label2.Visible := True;
        Label4.Visible := True;
        Label5.Visible := False;
        SpinEdit1.Visible := True;
        Edit1.Visible  := True;
        Edit4.Visible   := True;
        Edit5.Visible  := False;
        Edit6.Visible  := False;
        CheckBox1.Enabled := True;
        CheckBox2.Visible := True;
        CheckBox3.Enabled := False;
        Select2.Visible := True;
        Select4.Visible := False;
        Select3.Visible := False;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        if Tensio > 0 then
          Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
        {$ifdef testing}
        Panel3.Top := 287;
        {$else}
        Panel3.Top := 215;
        {$endif}
        HelpContext := 13;
      end;
    3:begin // MSI //
        Label1.Visible := True;
        Label2.Visible := True;
        Label4.Visible := True;
        Label5.Visible := True;
        Label6.Visible := True;
        Label7.Visible := True;
        SpinEdit1.Enabled := False;
        SpinEdit1.Value := 0;
        Edit1.Visible  := True;
        Edit2.Visible  := True;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        Edit6.Visible  := False;
        Edit7.Visible  := True;
        CheckBox1.Enabled := False;
        CheckBox1.Checked := True;
        CheckBox2.Checked := True;
        CheckBox2.Enabled := False;
        CheckBox3.Visible := False;
        Select2.Visible := True;
        Select3.Visible := False;
        Select4.Visible := True;
        Panel3.Top := 145;
        Label6.Top := Label1.Top - 25;
        Label7.Top := Label6.Top;
        Edit2.Top  := Edit1.Top - 25;
        Edit7.Top  := Edit2.Top;
        Edit1.Left := 275;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        Edit1.Text := FloatToStr(t_slicing);
        Edit2.Text := FloatToStr(z_slice);
        Edit7.Text := FloatToStr(W_slice);
        HelpContext := 13;
      end;
    4:begin
        SpinEdit1.Visible := True;
        if SpinEdit1.Value = 0 then
          SpinEdit1.Value := 1;
        {$ifdef Linux}
        SpinEdit1.Min := 1;
        {$else}
        SpinEdit1.MinValue := 1;
        {$endif}
        Label2.Visible := True;
        Label5.Visible := False;
        Edit5.Visible  := False;
        Select3.Visible := False;
        CheckBox1.Enabled := True;
        CheckBox2.Enabled := False;
        CheckBox3.Enabled := False;
        CheckBox4.Visible := False;
        Panel3.Top := 145;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
        Soil.cbRF.ItemIndex := 1;
        Soil.cbRF.Enabled := False;
        Kparams.cbKF.ItemIndex := 2;
        Kparams.cbKF.Enabled := False;
        HelpContext := 12;
      end;
    5:begin  // UIM ///
        SpinEdit1.Visible := False;
        Label2.Visible := False;
        Label4.Visible := True;
        Label5.Visible := True;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        Select2.Visible := True;
        Select3.Visible := True;
        CheckBox1.Enabled := True;
        CheckBox2.Enabled := False;
        CheckBox3.Enabled := False;
        CheckBox4.Visible := True;
        Panel3.Top := 265;
        Soil.cbRF.ItemIndex := 1;
        Soil.cbRF.Enabled := False;
        Kparams.cbKF.ItemIndex := 2;
        Kparams.cbKF.Enabled := False;
        HelpContext := 12;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_front);
        if UseProfileForK = 1 then
        begin
          Edit5.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
          CheckBox4.Checked := True;
        end
        else
        begin
          CheckBox4.Checked := False;
          Select3.Enabled := False;
        end;
        if Edit4.Text <> '' then
          CheckBox1.Checked := True
        else
          CheckBox1.Checked := False;
        CheckBox1Click(Sender);
        if Edit5.Text <> '' then
          CheckBox4.Checked := True
        else
          CheckBox4.Checked := False;
        Edit1.Text := FloatToStr(Wfront);
      end;
    6:begin
        SpinEdit1.Visible := True;
        SpinEdit1.Value := 1;
        SpinEdit1.Enabled := False;
        Label1.Visible := False;
        Label2.Visible := True;
        Label4.Visible := True;
        Label5.Visible := False;
        Edit1.Visible  := False;
        Edit4.Visible  := True;
        Edit5.Visible  := False;
        Edit6.Visible  := False;
        Select2.Visible := True;
        Select3.Visible := False;
        CheckBox2.Enabled := False;
        CheckBox3.Enabled := False;
        CheckBox4.Visible := False;
        Panel3.Top := 265;
        HelpContext := 12;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
      end;
  end;
  Language;
end;
//----------------------------------------------------------
procedure TInverseInfo.CheckBox2Click(Sender: TObject);
begin
  if (CheckBox2.Checked = True) or (IPET_Type = 1) then
  begin
    if CheckBox2.Checked = False then
    begin
      ShowMessage('You must include this data.');
      CheckBox2.Checked := True;
    end;
    fl_retention := TrimLeft(fl_retention);
   // if (fl_retention = '') and (dumint = 9999) then Select4Click(Sender);
    Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
    Edit6.Visible  := True;
    Select4.Visible:= True;
  end
  else
  begin
    Edit6.Visible  := False;
    Select4.Visible:= False;
  end;
end;
//--------------------------------------------------------------
procedure TInverseInfo.Select1Click(Sender: TObject);
begin
  case IPET_Type of
  1,2,3,5,6: Main.SelectFile(fl_outflow, Edit3);
          4: Main.SelectFile(fl_pressure, Edit3);
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Select2Click(Sender: TObject);
begin
  case IPET_Type of
    1  : Main.SelectFile(fl_CumEvap, Edit4);
    2,6: Main.SelectFile(fl_pressure, Edit4);
    5  : Main.SelectFile(fl_front, Edit4);
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Select3Click(Sender: TObject);
begin
  case IPET_type of
  1,5: Main.SelectFile(fl_profile, Edit5);
  //2  : Main.SelectFile(fl_p_bot, Edit5)
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Select4Click(Sender: TObject);
begin
  Main.SelectFile(fl_retention, Edit6);
end;
//----------------------------------------------------------
procedure TInverseInfo.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked = True then
  begin
    if IPET_type = 1 then
    begin
      UseAdditionalHyConData := 1;
      Edit12.Text := Main.GetRelativeDirectory(BaseDir, TrimLeft(fl_HyConData));
    end;
    Edit12.Visible  := True;
    Select5.Visible:= True;
  end
  else
  begin
    UseAdditionalHyConData := 0;
    Edit12.Visible  := False;
    Select5.Visible:= False;
  end;
end;
//===============================================================================================================================
procedure TInverseInfo.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
begin
  if not AllowChangeLanguage then
    Exit;
  Msg[1] := 'Name of file which holds time evolution of cumulative outflow';
  Msg[2] := 'Name of file which holds time evolution of cumulative evaporation';
  Msg[3] := 'Name of file which holds final water content profile';
  Msg[4] := 'Name of file which holds time evolution of tensiometer reading';
  Msg[5] := 'Name of file which holds pressure head at the bottom';
  Msg[6] := 'Time when the slicing was performed = ';
  Msg[7] := 'Name of file which holds time evolution of cumulative inflow';
  Msg[8] := 'Thickness of the sliced layer';
  Msg[9] := 'V.W.C. of the sliced layer';
  Msg[10]:= 'Add infiltrating front in the objective function';
  Msg[11]:= 'Add final water content profile in the objective function';
  Msg[12]:= 'V.W.C. of the wetting front =';
  Msg[13]:= 'Name of file which holds time evolution of depth of infiltrating front';
  Msg[14]:= 'Name of file which holds time evolution of pressure head and water content at the same depth';
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption             := ReadString(S, 'Caption', '');
        CheckBox5.Caption   := ReadString(S, 'CheckBox5.Caption', '');
        Label4.Caption      := ReadString(S, 'Label4.Caption', '');
        Label3.Caption      := ReadString(S, 'Label3.Caption', '');
        Label5.Caption      := ReadString(S, 'Label5.Caption', '');
        Label2.Caption      := ReadString(S, 'Label2.Caption', '');
        CheckBox1.Caption   := ReadString(S, 'CheckBox1.Caption', '');
        CheckBox4.Caption   := ReadString(S, 'CheckBox4.Caption', '');
        Label1.Caption      := ReadString(S, 'Label1.Caption', '');
        Label6.Caption      := ReadString(S, 'Label6.Caption', '');
        Label7.Caption      := ReadString(S, 'Label7.Caption', '');
        CheckBox2.Caption   := ReadString(S, 'CheckBox2.Caption', '');
        Execute.Caption     := ReadString(S, 'Execute.Caption', '');
        Next.Caption        := ReadString(S, 'Next.Caption', '');
        Back.Caption        := ReadString(S, 'Back.Caption', '');
        CheckBox3.Caption   := ReadString(S, 'CheckBox3.Caption', '');
        i := cbType.ItemIndex;
        cbType.Items.Text := StringReplace(ReadString(S, 'cbType.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
        cbType.ItemIndex := i;
        for i := 1 to 14 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  case IPET_type of
  1:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[2];
      Label5.Caption := Msg[3];
    end;
  2:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[4];
      Label5.Caption := Msg[5];                                                                
    end;
  3:begin
      Label1.Caption := Msg[6];
      Label3.Caption := Msg[7];
      Label6.Caption := Msg[8];
      Label7.Caption := Msg[9];
    end;
  4:begin
      Label3.Caption := Msg[4];
    end;
  5:begin
      CheckBox1.Caption := Msg[10];
      CheckBox4.Caption := Msg[11];
      Label1.Caption := Msg[12];
      Label3.Caption := Msg[6];
      Label4.Caption := Msg[13];
      Label5.Caption := Msg[3];
    end;
  6:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[14];
    end;
  end;
  Edit7.Left := Label7.Left + Label7.Width;
  Edit1.Left := Label1.Left + Label1.Width;
  Edit2.Left := Label6.Left + Label6.Width;
end;

procedure TInverseInfo.TableEdit3Click(Sender: TObject);
begin
end;
//----------------------------------------------------------
procedure TInverseInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;
//--------------------------------------------------------------
procedure TInverseInfo.BackClick(Sender: TObject);
begin
  GoAhead := False;
  DialogBox := 1;
  Close;
end;
//--------------------------------------------------------------
procedure TInverseInfo.NextClick(Sender: TObject);
begin
  GoAhead := true;
  DialogBox := 2;
  Close;
end;
//--------------------------------------------------------------
procedure TInverseInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if water = 1 then
  begin
    if CheckBox1.Checked = True then
      independent := 1
    else
      independent:= 0;
    if CheckBox2.Checked = True then
      AddRetData  := 1
    else
      AddRetData := 0;
    if IPET_type = 1 then
      fl_CumEvap := Main.GetAbsoluteDirectory(BaseDir, Edit4.Text);
    if CheckBox2.Checked then
      fl_retention := Main.GetAbsoluteDirectory(BaseDir, Edit6.Text);
    case IPET_Type of
      1: ;
      2,4: W_end := StrToFloat(Edit1.Text);
      5: Wfront := StrToFloat(Edit1.Text);
    end;
    case IPET_type of
    1:begin
        independent := 1;
        fl_outflow := Main.GetAbsoluteDirectory(BaseDir, Edit3.Text);
        fl_profile := Main.GetAbsoluteDirectory(BaseDir, Edit5.Text);
        if CheckBox4.Checked then
        begin
          UseOutFlowForK := 1;
          ic_type := 3;
        end
        else
        begin
          UseOutFlowForK := 0;
          ic_type := 1;
          KsatFix := 1;
        end;
      end;
    2:begin
      //  fl_p_bot := Main.GetAbsoluteDirectory(BaseDir, Edit5.Text);
      //  W_end := StrToFloat(Edit1.Text);
        fl_outflow := Main.GetAbsoluteDirectory(BaseDir, Edit3.Text);
        if CheckBox1.Checked then
          independent := 1
        else
          independent := 0;
        if Tensio = 2 then
          NumObs := 2;
        if CheckBox4.Checked then
          UseOutFlowForK := 1
        else
          UseOutFlowForK := 0;
        if (CheckBox5.Checked) or (CheckBox4.Checked) then
          l_bc_type := 4
        else
          l_bc_type := 5;
      end;
      3:begin // MSI //
          t_slicing := StrToFloat(Edit1.Text);
          z_slice   := StrToFloat(Edit2.Text);
          W_slice   := StrToFloat(Edit7.Text);
        end;
      5:begin // UIM //
          if not CheckBox1.Checked then
            fl_front := '';
          if not CheckBox4.Checked then
            fl_profile := '';
        end;
    end;
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Help1Click(Sender: TObject);
begin
//  Application.HelpCommand(HELP_CONTEXT,00000011);
end;
//----------------------------------------------------------
procedure TInverseInfo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {$ifdef Linux}
  if Key = Key_F2 then
  {$else}
  if Key = VK_F2 then
  {$endif}
    OutflowWeight := StrToFloat(InputBox('Hidden function', 'Magnification of OutFlowWeight', '2'));
//  if (Key=VK_F1) then Help1Click(Sender);
end;
//----------------------------------------------------------

procedure TInverseInfo.Select5Click(Sender: TObject);
begin
  Main.SelectFile(fl_HyConData, Edit12);
end;

procedure TInverseInfo.SpinEdit1Change(Sender: TObject);
begin
  CheckBox5.Enabled := False;
 // CheckBox5.Checked := False;
  Tensio := SpinEdit1.Value;
  Case Tensio of
  0..1:
    begin
      if IPET_type = 4 then
      begin
        Label4.Visible := False;
        Edit4.Visible  := False;
        Select2.Visible:= False;
      end;
    end;
  2:begin
      if IPET_type = 2 then
      begin
       // CheckBox4.Checked := True;
        CheckBox5.Enabled := True;
        Label4.Visible  := True;
        Edit4.Visible   := True;
        Select2.Visible := True;
      end;
    end;
  end;
 if (Tensio = 0) and (IPET_Type = 2) then
 begin
   Label4.Enabled  := False;
   Select2.Enabled := False;
   CheckBox4.Checked := True;
 end
 else
 begin
   Label4.Enabled  := True;
   Select2.Enabled := True;
 end;
 Language;
end;

procedure TInverseInfo.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
    CheckBox4.Checked := False;
end;

procedure TInverseInfo.CheckBox4Click(Sender: TObject);
begin
  if IPET_type = 5 then
    if CheckBox4.Checked = False then
    begin
      Edit5.Text := '';
      Select3.Enabled := False;
    end
    else
      Select3.Enabled := True;
end;

procedure TInverseInfo.CheckBox1Click(Sender: TObject);
begin
  if IPET_type = 5 then
    if CheckBox1.Checked = False then
    begin
      Edit4.Text := '';
      Select2.Enabled := False;
      Edit1.Visible   := False;
      Label1.Visible  := False;
    end
    else
    begin
      Select2.Enabled := True;
      Edit1.Visible   := True;
      Label1.Visible  := True;
    end;
end;

end.
