{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit StringGrid;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QGrids, Types, Qt;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids;
{$endif}

type
  TTable = class(TForm)
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
  private
    { Private  }
  public
    { Public  }
  end;

var
  Table: TTable;

implementation

uses WASH1dMAIN, Atmos_BC;

{$R *.xfm}

//----------------------------------------------------------
procedure TTable.Button2Click(Sender: TObject);
begin
  StringGrid1.RowCount := StringGrid1.RowCount + 1;
end;

procedure TTable.Button3Click(Sender: TObject);
begin
  StringGrid1.RowCount := StringGrid1.RowCount - 1;
end;

procedure TTable.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if ARow >= 2 then
    begin
    dumint := StringGrid1.Canvas.TextWidth(StringGrid1.Cells[ACol,ARow]);
    dumint := Rect.Right - dumint - 2;
    StringGrid1.Canvas.FillRect(Rect);
    StringGrid1.Canvas.TextOut(dumint, Rect.Top, StringGrid1.Cells[ACol,ARow]);
    end;
end;

procedure TTable.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with Sender as TStringGrid do
    {$ifdef Linux}
    if (Key =  Key_RETURN) or (Key = Key_DOWN) then
    {$else}
    if (Key =  VK_RETURN) or (Key = VK_DOWN) then
    {$endif}
      begin
      Key := 0;
      if Row = RowCount - 1 then
        begin
        Row := 2;
        if Col < ColCount - 1 then
          Col := Col + 1
        else
          Col :=  1;
        end
      else
        Row := Row + 1;
      end;
end;

end.

