program WASH_1D;

{%ToDo 'WASH_1D.todo'}

uses
  {$ifdef Linux}
  QForms,
  {$else}
  Forms,
  {$endif}
  WASH1dMain in 'WASH1dMain.pas' {Main},
  Greeting in 'Greeting.pas' {GreetingBox},
  G_Information in 'G_Information.pas' {GeneralInfo},
  W_Information in 'W_Information.pas' {WaterInfo},
  RC_Params in 'RC_Params.pas' {Soil},
  K_Params in 'K_Params.pas' {Kparams},
  Atmos_BC in 'Atmos_BC.pas' {AtmosBC},
  I_s_Information in 'I_s_Information.pas' {SoluteInverseInfo},
  S_Information in 'S_Information.pas' {SoluteInfo},
  Recent in 'Recent.pas' {RecentFile},
  En_Factor in 'En_Factor.pas' {EnFactor},
  THC_Params in 'THC_Params.pas' {THCparams},
  StringGrid in 'StringGrid.pas' {Table},
  I_Information in 'I_Information.pas' {InverseInfo},
  P_Estimator in 'P_Estimator.pas' {ParamEstimator},
  Pos_Information in 'Pos_Information.pas' {PositionInfo},
  FigFileMaker in 'FigFileMaker.pas',
  Output in 'Output.pas',
  MyMsgDlg in 'MyMsgDlg.pas' {MyMessageDlg},
  Numerical_Detail_of_Water_Flow in 'Numerical_Detail_of_Water_Flow.pas' {NumericalDetailOfWaterFlow},
  Simulation in 'Simulation.pas',
  Help_Search in 'Help_Search.pas' {HelpSearch},
  RootFinder in 'RootFinder.pas',
  ST_params in 'ST_params.pas' {STparams};

{$R *.res}

begin
  Application.Initialize;
  Application.Title := 'WASH_1D';
  Application.HelpFile := '';
  Application.CreateForm(TMain, Main);
  Application.CreateForm(THelpSearch, HelpSearch);
  Application.CreateForm(TTable, Table);
  Application.CreateForm(TMyMessageDlg, MyMessageDlg);
  Application.Run;
end.
